# swagger-java-client

APIs.io Search API
- API version: V1
  - Build date: 2023-12-01T00:21:26.758523927Z[GMT]

This is the API behind the APIs.io search engine.


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.SearchApi;

import java.io.File;
import java.util.*;

public class SearchApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: api_key
        ApiKeyAuth api_key = (ApiKeyAuth) defaultClient.getAuthentication("api_key");
        api_key.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //api_key.setApiKeyPrefix("Token");

        SearchApi apiInstance = new SearchApi();
        APIsJSON body = new APIsJSON(); // APIsJSON | 
        try {
            APIsJSON result = apiInstance.addAPI(body);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling SearchApi#addAPI");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.SearchApi;

import java.io.File;
import java.util.*;

public class SearchApiExample {

    public static void main(String[] args) {
        
        SearchApi apiInstance = new SearchApi();
        String search = "search_example"; // String | Keyword to search by.
        String type = "type_example"; // String | Type to search by.
        String maintainer = "maintainer_example"; // String | Maintainer to search by.
        String limit = "limit_example"; // String | 
        String page = "page_example"; // String | 
        try {
            Search result = apiInstance.searchAPIs(search, type, maintainer, limit, page);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling SearchApi#searchAPIs");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.SearchApi;

import java.io.File;
import java.util.*;

public class SearchApiExample {

    public static void main(String[] args) {
        
        SearchApi apiInstance = new SearchApi();
        String search = "search_example"; // String | Keyword to search by.
        String limit = "limit_example"; // String | 
        String page = "page_example"; // String | 
        try {
            Search result = apiInstance.searchMaintainers(search, limit, page);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling SearchApi#searchMaintainers");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://ibmwu99rx3.execute-api.us-east-1.amazonaws.com/staging*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*SearchApi* | [**addAPI**](docs/SearchApi.md#addAPI) | **POST** /search/apis | Submit API
*SearchApi* | [**searchAPIs**](docs/SearchApi.md#searchAPIs) | **GET** /search/apis | Search APIs
*SearchApi* | [**searchMaintainers**](docs/SearchApi.md#searchMaintainers) | **GET** /search/maintainers | Search Maintainers

## Documentation for Models

 - [API](docs/API.md)
 - [APIsJSON](docs/APIsJSON.md)
 - [AnyOfSearchDataItems](docs/AnyOfSearchDataItems.md)
 - [Contact](docs/Contact.md)
 - [DiagnosticSeverity](docs/DiagnosticSeverity.md)
 - [Formats](docs/Formats.md)
 - [Given](docs/Given.md)
 - [HumanReadableSeverity](docs/HumanReadableSeverity.md)
 - [Include](docs/Include.md)
 - [Latest](docs/Latest.md)
 - [LatestProperties](docs/LatestProperties.md)
 - [LatestPropertiesRules](docs/LatestPropertiesRules.md)
 - [LatestRules](docs/LatestRules.md)
 - [Maintainer](docs/Maintainer.md)
 - [MetaInformation](docs/MetaInformation.md)
 - [Property](docs/Property.md)
 - [PublishAPIs](docs/PublishAPIs.md)
 - [PublishMaintainers](docs/PublishMaintainers.md)
 - [PublishProperties](docs/PublishProperties.md)
 - [PublishTags](docs/PublishTags.md)
 - [Rule](docs/Rule.md)
 - [Search](docs/Search.md)
 - [SearchLinks](docs/SearchLinks.md)
 - [SearchMeta](docs/SearchMeta.md)
 - [Severity](docs/Severity.md)
 - [Tag](docs/Tag.md)
 - [Then](docs/Then.md)
 - [UpdateMaintainers](docs/UpdateMaintainers.md)
 - [UpdateProperties](docs/UpdateProperties.md)
 - [UpdateTags](docs/UpdateTags.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

info@apievangelist.com
