/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.APIsJSON;
import io.swagger.client.model.Search;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SearchApi {
    private ApiClient apiClient;

    public SearchApi() {
        this(Configuration.getDefaultApiClient());
    }

    public SearchApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for addAPI
     * @param body  (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call addAPICall(APIsJSON body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = body;
        
        // create path and map variables
        String localVarPath = "/search/apis";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "api_key" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call addAPIValidateBeforeCall(APIsJSON body, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'body' is set
        if (body == null) {
            throw new ApiException("Missing the required parameter 'body' when calling addAPI(Async)");
        }
        
        com.squareup.okhttp.Call call = addAPICall(body, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Submit API
     * Submit an API to be included in the index.
     * @param body  (required)
     * @return APIsJSON
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public APIsJSON addAPI(APIsJSON body) throws ApiException {
        ApiResponse<APIsJSON> resp = addAPIWithHttpInfo(body);
        return resp.getData();
    }

    /**
     * Submit API
     * Submit an API to be included in the index.
     * @param body  (required)
     * @return ApiResponse&lt;APIsJSON&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<APIsJSON> addAPIWithHttpInfo(APIsJSON body) throws ApiException {
        com.squareup.okhttp.Call call = addAPIValidateBeforeCall(body, null, null);
        Type localVarReturnType = new TypeToken<APIsJSON>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Submit API (asynchronously)
     * Submit an API to be included in the index.
     * @param body  (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call addAPIAsync(APIsJSON body, final ApiCallback<APIsJSON> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = addAPIValidateBeforeCall(body, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<APIsJSON>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for searchAPIs
     * @param search Keyword to search by. (optional)
     * @param type Type to search by. (optional)
     * @param maintainer Maintainer to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call searchAPIsCall(String search, String type, String maintainer, String limit, String page, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/search/apis";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));
        if (maintainer != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("maintainer", maintainer));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call searchAPIsValidateBeforeCall(String search, String type, String maintainer, String limit, String page, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = searchAPIsCall(search, type, maintainer, limit, page, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Search APIs
     * Searching across all APIs by keyword, property type, or maintainer.
     * @param search Keyword to search by. (optional)
     * @param type Type to search by. (optional)
     * @param maintainer Maintainer to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @return Search
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Search searchAPIs(String search, String type, String maintainer, String limit, String page) throws ApiException {
        ApiResponse<Search> resp = searchAPIsWithHttpInfo(search, type, maintainer, limit, page);
        return resp.getData();
    }

    /**
     * Search APIs
     * Searching across all APIs by keyword, property type, or maintainer.
     * @param search Keyword to search by. (optional)
     * @param type Type to search by. (optional)
     * @param maintainer Maintainer to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @return ApiResponse&lt;Search&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Search> searchAPIsWithHttpInfo(String search, String type, String maintainer, String limit, String page) throws ApiException {
        com.squareup.okhttp.Call call = searchAPIsValidateBeforeCall(search, type, maintainer, limit, page, null, null);
        Type localVarReturnType = new TypeToken<Search>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search APIs (asynchronously)
     * Searching across all APIs by keyword, property type, or maintainer.
     * @param search Keyword to search by. (optional)
     * @param type Type to search by. (optional)
     * @param maintainer Maintainer to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call searchAPIsAsync(String search, String type, String maintainer, String limit, String page, final ApiCallback<Search> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = searchAPIsValidateBeforeCall(search, type, maintainer, limit, page, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Search>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for searchMaintainers
     * @param search Keyword to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call searchMaintainersCall(String search, String limit, String page, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/search/maintainers";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (search != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("search", search));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("limit", limit));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call searchMaintainersValidateBeforeCall(String search, String limit, String page, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = searchMaintainersCall(search, limit, page, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Search Maintainers
     * Search across all maintainers.
     * @param search Keyword to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @return Search
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Search searchMaintainers(String search, String limit, String page) throws ApiException {
        ApiResponse<Search> resp = searchMaintainersWithHttpInfo(search, limit, page);
        return resp.getData();
    }

    /**
     * Search Maintainers
     * Search across all maintainers.
     * @param search Keyword to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @return ApiResponse&lt;Search&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Search> searchMaintainersWithHttpInfo(String search, String limit, String page) throws ApiException {
        com.squareup.okhttp.Call call = searchMaintainersValidateBeforeCall(search, limit, page, null, null);
        Type localVarReturnType = new TypeToken<Search>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search Maintainers (asynchronously)
     * Search across all maintainers.
     * @param search Keyword to search by. (optional)
     * @param limit  (optional)
     * @param page  (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call searchMaintainersAsync(String search, String limit, String page, final ApiCallback<Search> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = searchMaintainersValidateBeforeCall(search, limit, page, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Search>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
