/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.Contact;
import io.swagger.client.model.MetaInformation;
import io.swagger.client.model.Property;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * The description of the API
 */
@Schema(description = "The description of the API")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-12-01T00:21:26.758523927Z[GMT]")

public class API implements AnyOfSearchDataItems {
  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("image")
  private String image = null;

  @SerializedName("baseURL")
  private String baseURL = null;

  @SerializedName("humanURL")
  private String humanURL = null;

  @SerializedName("tags")
  private List<String> tags = null;

  @SerializedName("properties")
  private List<Property> properties = new ArrayList<Property>();

  @SerializedName("contact")
  private List<Contact> contact = new ArrayList<Contact>();

  @SerializedName("meta")
  private List<MetaInformation> meta = null;

  public API name(String name) {
    this.name = name;
    return this;
  }

   /**
   * name
   * @return name
  **/
  @Schema(required = true, description = "name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public API description(String description) {
    this.description = description;
    return this;
  }

   /**
   * description of the API
   * @return description
  **/
  @Schema(required = true, description = "description of the API")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public API image(String image) {
    this.image = image;
    return this;
  }

   /**
   * URL of an image representing the API
   * @return image
  **/
  @Schema(required = true, description = "URL of an image representing the API")
  public String getImage() {
    return image;
  }

  public void setImage(String image) {
    this.image = image;
  }

  public API baseURL(String baseURL) {
    this.baseURL = baseURL;
    return this;
  }

   /**
   * baseURL
   * @return baseURL
  **/
  @Schema(required = true, description = "baseURL")
  public String getBaseURL() {
    return baseURL;
  }

  public void setBaseURL(String baseURL) {
    this.baseURL = baseURL;
  }

  public API humanURL(String humanURL) {
    this.humanURL = humanURL;
    return this;
  }

   /**
   * humanURL
   * @return humanURL
  **/
  @Schema(required = true, description = "humanURL")
  public String getHumanURL() {
    return humanURL;
  }

  public void setHumanURL(String humanURL) {
    this.humanURL = humanURL;
  }

  public API tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public API addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * tags to describe the API
   * @return tags
  **/
  @Schema(description = "tags to describe the API")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public API properties(List<Property> properties) {
    this.properties = properties;
    return this;
  }

  public API addPropertiesItem(Property propertiesItem) {
    this.properties.add(propertiesItem);
    return this;
  }

   /**
   * URLs
   * @return properties
  **/
  @Schema(required = true, description = "URLs")
  public List<Property> getProperties() {
    return properties;
  }

  public void setProperties(List<Property> properties) {
    this.properties = properties;
  }

  public API contact(List<Contact> contact) {
    this.contact = contact;
    return this;
  }

  public API addContactItem(Contact contactItem) {
    this.contact.add(contactItem);
    return this;
  }

   /**
   * Contact to reach if questions about API
   * @return contact
  **/
  @Schema(required = true, description = "Contact to reach if questions about API")
  public List<Contact> getContact() {
    return contact;
  }

  public void setContact(List<Contact> contact) {
    this.contact = contact;
  }

  public API meta(List<MetaInformation> meta) {
    this.meta = meta;
    return this;
  }

  public API addMetaItem(MetaInformation metaItem) {
    if (this.meta == null) {
      this.meta = new ArrayList<MetaInformation>();
    }
    this.meta.add(metaItem);
    return this;
  }

   /**
   * Get meta
   * @return meta
  **/
  @Schema(description = "")
  public List<MetaInformation> getMeta() {
    return meta;
  }

  public void setMeta(List<MetaInformation> meta) {
    this.meta = meta;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    API API = (API) o;
    return Objects.equals(this.name, API.name) &&
        Objects.equals(this.description, API.description) &&
        Objects.equals(this.image, API.image) &&
        Objects.equals(this.baseURL, API.baseURL) &&
        Objects.equals(this.humanURL, API.humanURL) &&
        Objects.equals(this.tags, API.tags) &&
        Objects.equals(this.properties, API.properties) &&
        Objects.equals(this.contact, API.contact) &&
        Objects.equals(this.meta, API.meta);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, image, baseURL, humanURL, tags, properties, contact, meta);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class API {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    baseURL: ").append(toIndentedString(baseURL)).append("\n");
    sb.append("    humanURL: ").append(toIndentedString(humanURL)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    properties: ").append(toIndentedString(properties)).append("\n");
    sb.append("    contact: ").append(toIndentedString(contact)).append("\n");
    sb.append("    meta: ").append(toIndentedString(meta)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
