/*
 * APIs.io Search API
 * This is the API behind the APIs.io search engine.
 *
 * OpenAPI spec version: V1
 * Contact: info@apievangelist.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.API;
import io.swagger.client.model.Include;
import io.swagger.client.model.Maintainer;
import io.swagger.client.model.Tag;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.threeten.bp.LocalDate;
/**
 * APIsJSON
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-12-01T00:21:26.758523927Z[GMT]")

public class APIsJSON {
  @SerializedName("name")
  private String name = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("image")
  private String image = null;

  @SerializedName("created")
  private LocalDate created = null;

  @SerializedName("modified")
  private LocalDate modified = null;

  @SerializedName("specificationVersion")
  private String specificationVersion = null;

  @SerializedName("apis")
  private List<API> apis = null;

  @SerializedName("maintainers")
  private List<Maintainer> maintainers = null;

  @SerializedName("tags")
  private List<Tag> tags = null;

  @SerializedName("include")
  private List<Include> include = null;

  public APIsJSON name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The name of the service described
   * @return name
  **/
  @Schema(required = true, description = "The name of the service described")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public APIsJSON description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the service
   * @return description
  **/
  @Schema(required = true, description = "Description of the service")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public APIsJSON url(String url) {
    this.url = url;
    return this;
  }

   /**
   * URL where the apis.json file will live
   * @return url
  **/
  @Schema(required = true, description = "URL where the apis.json file will live")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public APIsJSON image(String image) {
    this.image = image;
    return this;
  }

   /**
   * Image to represent the API
   * @return image
  **/
  @Schema(description = "Image to represent the API")
  public String getImage() {
    return image;
  }

  public void setImage(String image) {
    this.image = image;
  }

  public APIsJSON created(LocalDate created) {
    this.created = created;
    return this;
  }

   /**
   * Date when the file was created
   * @return created
  **/
  @Schema(description = "Date when the file was created")
  public LocalDate getCreated() {
    return created;
  }

  public void setCreated(LocalDate created) {
    this.created = created;
  }

  public APIsJSON modified(LocalDate modified) {
    this.modified = modified;
    return this;
  }

   /**
   * Date when the file was modified
   * @return modified
  **/
  @Schema(description = "Date when the file was modified")
  public LocalDate getModified() {
    return modified;
  }

  public void setModified(LocalDate modified) {
    this.modified = modified;
  }

  public APIsJSON specificationVersion(String specificationVersion) {
    this.specificationVersion = specificationVersion;
    return this;
  }

   /**
   * APIs.json spec version, latest is 0.14
   * @return specificationVersion
  **/
  @Schema(description = "APIs.json spec version, latest is 0.14")
  public String getSpecificationVersion() {
    return specificationVersion;
  }

  public void setSpecificationVersion(String specificationVersion) {
    this.specificationVersion = specificationVersion;
  }

  public APIsJSON apis(List<API> apis) {
    this.apis = apis;
    return this;
  }

  public APIsJSON addApisItem(API apisItem) {
    if (this.apis == null) {
      this.apis = new ArrayList<API>();
    }
    this.apis.add(apisItem);
    return this;
  }

   /**
   * All the APIs of this service
   * @return apis
  **/
  @Schema(description = "All the APIs of this service")
  public List<API> getApis() {
    return apis;
  }

  public void setApis(List<API> apis) {
    this.apis = apis;
  }

  public APIsJSON maintainers(List<Maintainer> maintainers) {
    this.maintainers = maintainers;
    return this;
  }

  public APIsJSON addMaintainersItem(Maintainer maintainersItem) {
    if (this.maintainers == null) {
      this.maintainers = new ArrayList<Maintainer>();
    }
    this.maintainers.add(maintainersItem);
    return this;
  }

   /**
   * Maintainers of the apis.json file
   * @return maintainers
  **/
  @Schema(description = "Maintainers of the apis.json file")
  public List<Maintainer> getMaintainers() {
    return maintainers;
  }

  public void setMaintainers(List<Maintainer> maintainers) {
    this.maintainers = maintainers;
  }

  public APIsJSON tags(List<Tag> tags) {
    this.tags = tags;
    return this;
  }

  public APIsJSON addTagsItem(Tag tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<Tag>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Tags to describe the service
   * @return tags
  **/
  @Schema(description = "Tags to describe the service")
  public List<Tag> getTags() {
    return tags;
  }

  public void setTags(List<Tag> tags) {
    this.tags = tags;
  }

  public APIsJSON include(List<Include> include) {
    this.include = include;
    return this;
  }

  public APIsJSON addIncludeItem(Include includeItem) {
    if (this.include == null) {
      this.include = new ArrayList<Include>();
    }
    this.include.add(includeItem);
    return this;
  }

   /**
   * Links to other apis.json definitions included in this service.
   * @return include
  **/
  @Schema(description = "Links to other apis.json definitions included in this service.")
  public List<Include> getInclude() {
    return include;
  }

  public void setInclude(List<Include> include) {
    this.include = include;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    APIsJSON apIsJSON = (APIsJSON) o;
    return Objects.equals(this.name, apIsJSON.name) &&
        Objects.equals(this.description, apIsJSON.description) &&
        Objects.equals(this.url, apIsJSON.url) &&
        Objects.equals(this.image, apIsJSON.image) &&
        Objects.equals(this.created, apIsJSON.created) &&
        Objects.equals(this.modified, apIsJSON.modified) &&
        Objects.equals(this.specificationVersion, apIsJSON.specificationVersion) &&
        Objects.equals(this.apis, apIsJSON.apis) &&
        Objects.equals(this.maintainers, apIsJSON.maintainers) &&
        Objects.equals(this.tags, apIsJSON.tags) &&
        Objects.equals(this.include, apIsJSON.include);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, url, image, created, modified, specificationVersion, apis, maintainers, tags, include);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class APIsJSON {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    modified: ").append(toIndentedString(modified)).append("\n");
    sb.append("    specificationVersion: ").append(toIndentedString(specificationVersion)).append("\n");
    sb.append("    apis: ").append(toIndentedString(apis)).append("\n");
    sb.append("    maintainers: ").append(toIndentedString(maintainers)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    include: ").append(toIndentedString(include)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
